
function onClickHandler(info, tab) {

	var ID = function () {return 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
        var r = Math.random()*16|0, v = c == 'x' ? r : (r&0x3|0x8);
        return v.toString(16);
    });};
    
  	var selection = info.selectionText;
if(escape(selection).indexOf("%u")<0){alert("Your selection doesn't have Chinese text."); return;}
if(selection.length>1000){alert("Your selection should be less than 1000 characters."); return;}
	  if (info.menuItemId == "py") {	    
	    document.body.innerHTML += '<form id="cnpyform" action="https://www.purpleculture.net/chinese-pinyin-converter/?session='+ID()+'" method="post" target="_blank"><input type="hidden" name="convert" value="y"/><input type="hidden" name="wdqchs" value="'+selection+'"></form>';
		 document.getElementById("cnpyform").submit();
		 
		 document.body.removeChild(document.getElementById( 'cnpyform'));
		 
	   } else if (info.menuItemId == "sctc") {
	   	
//	   	 tab_id = 0;
//	   	 
//		    chrome.tabs.create({'url': "https://www.purpleculture.net/traditional-simplified-converter/"}, function(tab) {
//		    // Tab opened. Wait until page loads, from here it is not working
//		    	
//		    chrome.tabs.update(tab.id, {active: true});
//		    tab_id = tab.id; 
//		    //alert(tab_id);
//		   
//	  	  });
//	   
//	   
//	   	chrome.tabs.onUpdated.addListener(function(tabId, changeInfo, tab) {
//		    // make sure the status is 'complete' and it's the right tab
//		    alert("update:"+tab.id +"|"+tab_id);
//		    if (tab.id == tab_id && changeInfo.status == 'complete') {
//		    		alert('done');
//
//		        chrome.tabs.executeScript(tab.id, {code:"document.getElementById('hanzi').value = '"+selection+"';  document.getElementsByName('inputcn').submit(); "});
//		    } 	      
//	  });
	   
	   	   document.body.innerHTML += '<form id="sctcform" action="https://www.purpleculture.net/traditional-simplified-converter/" method="post" target="_blank"><input type="hidden" name="type" value="sctc"><input type="hidden" name="hanzi" value="'+selection+'"></form>';
		   document.getElementById("sctcform").submit();
		   document.body.removeChild(document.getElementById( 'sctcform'));
	   
	   } else if (info.menuItemId == "tcsc") {
	   
	   	   document.body.innerHTML += '<form id="tcscform" action="https://www.purpleculture.net/traditional-simplified-converter/" method="post" target="_blank"><input type="hidden" name="type" value="tcsc"><input type="hidden" name="hanzi" value="'+selection+'"></form>';
		   document.getElementById("tcscform").submit();
		   document.body.removeChild(document.getElementById( 'tcscform'));

	   
	   } else if (info.menuItemId == "voc") {
	   	     document.body.innerHTML += '<form id="vocform" action="https://www.purpleculture.net/vocabulary-list-generator/?session='+ID()+'" method="post" target="_blank"><input type="hidden" name="generate" value="y"/><input type="hidden" name="words" value="'+selection+'"></form>';
		   document.getElementById("vocform").submit();
		   document.body.removeChild(document.getElementById( 'vocform'));


	  } else if (info.menuItemId == "dic") {
		var win=window.open('https://www.purpleculture.net/chinese-english-dictionary/?word='+selection, '_blank');
		win.focus();
	  } else if (info.menuItemId == "translator") {
		var win=window.open('http://translate.google.com/#zh-CN/en/'+selection, '_blank');
		win.focus();
	  }
	  else if (info.menuItemId == "speak") {
		var msg = new SpeechSynthesisUtterance();
		var voices = window.speechSynthesis.getVoices();
		msg.voice = voices[10]; // Note: some voices don't support altering params
		msg.voiceURI = 'native';
		msg.volume = 1; // 0 to 1
		msg.rate = 0.6; // 0.1 to 10
		msg.pitch = 1; //0 to 2
		msg.text = selection;
		msg.lang = 'zh-CN';
		speechSynthesis.speak(msg);
	  }
	  
	   else {
	    console.log("item " + info.menuItemId + " was clicked");
	    console.log("info: " + JSON.stringify(info));
	    console.log("tab: " + JSON.stringify(tab)); 
	  }
	
};

chrome.contextMenus.onClicked.addListener(onClickHandler);


chrome.runtime.onInstalled.addListener(function() {

    var id = chrome.contextMenus.create({"title": "Chinese Tools", "contexts":["selection"],"id": "selection"});
	chrome.contextMenus.create({"title": "Convert to Pinyin/Zhuyin", "parentId": id, "contexts":["selection"],"id": "py"});
	chrome.contextMenus.create({"title": "Convert to Simplified Chinese", "parentId": id, "contexts":["selection"],"id": "tcsc"});
	chrome.contextMenus.create({"title": "Convert to Traditional Chinese", "parentId": id, "contexts":["selection"],"id": "sctc"});
	chrome.contextMenus.create({"title": "Generate Vocabulary List", "parentId": id, "contexts":["selection"],"id": "voc"});
	chrome.contextMenus.create({"title": "Search in Dictionary", "parentId": id, "contexts":["selection"],"id": "dic"});
	chrome.contextMenus.create({"title": "Translate to English", "parentId": id, "contexts":["selection"],"id": "translator"});
	chrome.contextMenus.create({"title": "Speak it", "parentId": id, "contexts":["selection"],"id": "speak"});

	
	

  
});

